const { mergeWith } = require('docz-utils')
const fs = require('fs-extra')

let custom = {}
const hasGatsbyConfig = fs.existsSync('./gatsby-config.custom.js')

if (hasGatsbyConfig) {
  try {
    custom = require('./gatsby-config.custom')
  } catch (err) {
    console.error(
      `Failed to load your gatsby-config.js file : `,
      JSON.stringify(err),
    )
  }
}

const config = {
  pathPrefix: '/',

  siteMetadata: {
    title: '组件库左上角标题',
    description: 'demo的一个组件库',
  },
  plugins: [
    {
      resolve: 'gatsby-theme-docz',
      options: {
        themeConfig: {},
        src: './',
        gatsbyRoot: null,
        themesDir: 'theme',
        mdxExtensions: ['.md', '.mdx'],
        docgenConfig: {},
        menu: ['快速上手', '业务组件'],
        mdPlugins: [],
        hastPlugins: [],
        ignore: [],
        typescript: false,
        ts: false,
        propsParser: true,
        'props-parser': true,
        debug: false,
        native: false,
        openBrowser: null,
        o: null,
        open: null,
        'open-browser': null,
        root: '/Users/demo/react组件库/.docz',
        base: '/',
        source: './',
        'gatsby-root': null,
        files: ['./src/components/**/*.mdx', './src/*.mdx'],
        public: '/public',
        dest: 'docsite',
        d: '.docz/dist',
        editBranch: 'master',
        eb: 'master',
        'edit-branch': 'master',
        config: '',
        title: '组件库左上角标题',
        description: 'demo的一个组件库',
        host: 'localhost',
        port: 3000,
        p: 3000,
        separator: '-',
        paths: {
          root: '/Users/demo/react组件库',
          templates:
            '/Users/demo/react组件库/node_modules/docz-core/dist/templates',
          docz: '/Users/demo/react组件库/.docz',
          cache: '/Users/demo/react组件库/.docz/.cache',
          app: '/Users/demo/react组件库/.docz/app',
          appPackageJson: '/Users/demo/react组件库/package.json',
          appTsConfig: '/Users/demo/react组件库/tsconfig.json',
          gatsbyConfig: '/Users/demo/react组件库/gatsby-config.js',
          gatsbyBrowser: '/Users/demo/react组件库/gatsby-browser.js',
          gatsbyNode: '/Users/demo/react组件库/gatsby-node.js',
          gatsbySSR: '/Users/demo/react组件库/gatsby-ssr.js',
          importsJs: '/Users/demo/react组件库/.docz/app/imports.js',
          rootJs: '/Users/demo/react组件库/.docz/app/root.jsx',
          indexJs: '/Users/demo/react组件库/.docz/app/index.jsx',
          indexHtml: '/Users/demo/react组件库/.docz/app/index.html',
          db: '/Users/demo/react组件库/.docz/app/db.json',
        },
      },
    },
  ],
}

const merge = mergeWith((objValue, srcValue) => {
  if (Array.isArray(objValue)) {
    return objValue.concat(srcValue)
  }
})

module.exports = merge(config, custom)
